// The following ifdef block is the standard way of creating macros which make exporting 
// from a DLL simpler. All files within this DLL are compiled with the ISO_WINCMD_EXPORTS
// symbol defined on the command line. this symbol should not be defined on any project
// that uses this DLL. This way any other project whose source files include this file see 
// ISO_WINCMD_API functions as being imported from a DLL, whereas this DLL sees symbols
// defined with this macro as being exported.
#ifdef ISO_WINCMD_EXPORTS
#define ISO_WINCMD_API __declspec(dllexport)
#else
#define ISO_WINCMD_API __declspec(dllimport)
#endif

#ifdef __cplusplus
extern "C" {
#endif

#define CALLDECL __stdcall

//0 Success
#define E_END_ARCHIVE       10  //No more files in archive
#define E_NO_MEMORY         11  //Not enough memory
#define E_BAD_DATA          12  //Data is bad
#define E_BAD_ARCHIVE       13  //CRC error in archive data
#define E_UNKNOWN_FORMAT    14  //Archive format unknown
#define E_EOPEN             15  //Cannot open existing file
#define E_ECREATE           16  //Cannot create file
#define E_ECLOSE            17  //Error closing file
#define E_EREAD             18  //Error reading from file
#define E_EWRITE            19  //Error writing to file
#define E_SMALL_BUF         20  //Buffer too small
#define E_EABORTED          21  //Function aborted by user
#define E_NO_FILES          22  //No files found

#define E_TOO_MANY_FILES    23  //Too many files to pack
#define E_NOT_SUPPORTED     24  //Function not supported

// File Attributes
#define FA_READONLY         0x1     //Read-only file
#define FA_HIDDEN           0x2     //Hidden file
#define FA_SYSTEM           0x4     //System file
#define FA_VOLUME_ID        0x8     //Volume ID file
#define FA_DIRECTORY        0x10    //Directory
#define FA_ARCHIVE          0x20    //Archive file
#define FA_ANY              0x3F    //Any file

#define PK_SKIP             0       //Skip this file
#define PK_TEST             1       //Test file integrity
#define PK_EXTRACT          2       //Extract to disk
    
typedef struct {
    char* ArcName;
    int OpenMode;
    int OpenResult;
    char* CmtBuf;
    int CmtBufSize;
    int CmtSize;
    int CmtState;
} tOpenArchiveData;

typedef struct {
    char ArcName[260];
    char FileName[260];
    int Flags;
    int PackSize;
    int UnpSize;
    int HostOS;
    int FileCRC;
    int FileTime;
    int UnpVer;
    int Method;
    int FileAttr;
    char* CmtBuf;
    int CmtBufSize;
    int CmtSize;
    int CmtState;
} tHeaderData;

typedef int (CALLDECL *tChangeVolProc)(char *ArcName, int Mode);
typedef int (CALLDECL *tProcessDataProc)(const char *FileName, int Size);

ISO_WINCMD_API HANDLE CALLDECL OpenArchive (tOpenArchiveData *ArchiveData);
ISO_WINCMD_API int CALLDECL ReadHeader (HANDLE hArcData, tHeaderData *HeaderData);
ISO_WINCMD_API int CALLDECL ProcessFile (HANDLE hArcData, int Operation, char *DestPath, char *DestName);
ISO_WINCMD_API int CALLDECL CloseArchive (HANDLE hArcData);
ISO_WINCMD_API void CALLDECL SetChangeVolProc (HANDLE hArcData, tChangeVolProc pChangeVolProc1);
ISO_WINCMD_API void CALLDECL SetProcessDataProc (HANDLE hArcData, tProcessDataProc pProcessDataProc);

#ifdef __cplusplus
}
#endif